// tst.c	220703	Stadtmueller	mst3
//
//	test port-io   ---   you must have root-rights !!


#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/io.h>

//-------+---------+---------+---------+---------+---------+---------+---------+

// modified functions from <sys/io.h>

static __inline unsigned char
_inp (unsigned short int port)
{
  unsigned char _v;

  __asm__ __volatile__ ("inb %w1,%0":"=a" (_v):"Nd" (port));
  return _v;
}

static __inline void
_outp (unsigned short int port, unsigned char value)
{
  __asm__ __volatile__ ("outb %b0,%w1": :"a" (value), "Nd" (port));
}
//-------+---------+---------+---------+---------+---------+---------+---------+

main(int argc,char *argv[])

{
	long			port, i;
	char			dat;
	int				err;
	struct timespec	reqtim;
	struct timespec	remtim;
	clock_t			start, end;
	uid_t			uid, euid;

	port = 0x378;
	dat  = 0x55;

	uid  = getuid( );
	euid  = geteuid( );
	printf( "uid = 0x%x , euid = 0x%x \n", uid, euid );
	if ( err = setuid( 0 ) )
		printf( "error in setuid( 0 ) 0x%x \n", err);
	if ( err = seteuid( 0 ) )
		printf( "error in seteuid( 0 ) 0x%x \n", err);

	if ( ioperm(port, 3, 1) ) {			// get access to ports
		perror("ioperm");
		exit(1);
	}

	if ( err = setuid( uid ) )
		printf( "error in setuid( uid ) 0x%x \n", err);
	if ( err = seteuid( euid ) )
		printf( "error in seteuid( euid ) 0x%x \n", err);

/*
// min is 20 ms
	for ( i = 0; i < 20; i++ ) {		// count dat 10 sec
		_outp(port, dat);
//		outb(dat, port);
//		inb(port);
		usleep(500000);					// sleep 500 ms
		dat++;
	}
/*
// min is 20 ms
	reqtim.tv_sec = 0;
	reqtim.tv_nsec = 50;
	for ( i = 0; i < (20000 * 30); i++ ) {		// count dat 30 sec
		_outp(port, dat);
		nanosleep(&reqtim, &remtim);		// sleep 50 us
		dat++;
	}
//*/
// one clock is 10 ms
	start = clock();
	printf("CLOCKS_PER_SEC = %u, clock = %u \n", CLOCKS_PER_SEC, start);
	for ( i = 0; i < 10000000; i++ ) {		// count dat 15 sec
		_outp(port, dat);
		dat++;
	}
	end = clock();
	printf("CLOCKS_PER_SEC = %u, clock = %u \n", CLOCKS_PER_SEC, end);

	if ( ioperm(port, 3, 0) ) {			// release access to ports
		perror("ioperm");
		exit(1);
	}

	exit(0);


}		// end of tst_port
//-------+---------+---------+---------+---------+---------+---------+---------+

