#ifndef CDILIBERA_H_
#define CDILIBERA_H_

#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#define N_LIBERA_LINES	4	/* maximum number of Libera lines */
#define u16 unsigned short

enum LiberaParamIndex
{
  liberaIP,        /* sps IP address: 4 intergers */
  liberaMaxLength = 5,    /* in bytes */
};

typedef struct {
  int LiberaLine;		/* Libera line number */
  int cdiLine;
  CSPIHANDLE cspiEnvHen;
  
  char ipadr[32];      // "xxx.xxx.xxx.xxx"
  int dataSize;

} LIBERA_STRUCT;

int initLiberaForCDI(int busLine, int cdiLine, int numberDevices, char *parameterList);
int doLiberaRequest(CdiRequestInfoBlk *pReq, int step);
void execLiberaBus(CdiRequestInfoBlk *pReq);
int exitLibera(int ln);
int filterLiberaBus(int *parameter, int accessFlag);

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* CDILIBERA_H_ */


