# Makefile for TINE server generated on Thu Sep 21 12:33:59 2006

INCL = ../../tine/include
INCLCDI = ../lib

LIBTINE = -ltinemt
LIBCDI = -lcdi
CDISERV = cdihdwsrv-pdo

HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/dbtools.h \
	${INCL}/swaplib.h \
	${INCL}/toolkit.h \
	${INCL}/hstlib.h \
	${INCL}/almlib.h

CDIHDRS = ${INCLCDI}/cdi.def \
        ${INCLCDI}/cdi_prot.h \
        ${INCLCDI}/cdi.h \
        ${INCLCDI}/cdieqm.h \
        ${INCLCDI}/cdidb.h \
        ${INCLCDI}/tinecdi.h

OBJS = cdiserv.o pdoclient.o

CPP = g++ -I${INCL}
CC =  cc -c -DCAN_PDO -g -Wall -I${INCL} -I${INCLCDI}
CCL = cc -g -Wall
LM = -lm -lpthread  -lrt -ldl

all:	${CDISERV}
	touch all	

${CDISERV}: ${OBJS}
	${CCL} -o ${CDISERV} ${OBJS} ${LIBTINE}  ${LIBCDI}  ${LM}
	chmod a+s ${CDISERV}

cdiserv.o: cdiserv.c ${HDRS} ${CDIHDRS}
	${CC} cdiserv.c

pdoclient.o : pdoclient.h pdoclient.c
	${CC} pdoclient.c

clean:
	rm *.o

